﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDTTest
{
    public class MenuGroup : MenuItem
    {
        private List<MenuItem> _children;

        public MenuGroup()
        {
            _children = new List<MenuItem>();
        }

        // Uncomment these lines:

        /*
        /// <summary>Gets all children, both direct and recursive.</summary>
        public override IEnumerable<MenuItem> AllChildren
        {
            get
            {
                foreach (MenuItem child in _children)
                {
                    yield return child;

                    foreach (MenuItem subChild in child.AllChildren)
                        yield return subChild;
                }
            }
        }
        */

        /// <summary>Gets all direct children.</summary>
        public override IEnumerable<MenuItem> Children
        {
            get { return _children.AsEnumerable(); }
        }

        // Comment out this property:
        
        /// <summary>Gets all children, both direct and recursive.</summary>
        public override IEnumerable<MenuItem> AllChildren
        {
            get
            {
                foreach (MenuItem child in _children)
                {
                    yield return child;

                    foreach (MenuItem subChild in child.AllChildren)
                        yield return subChild;
                }
            }
        }
        

        public void AddChild(MenuItem child)
        {
            _children.Add(child);
        }
    }
}
